﻿
// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated from BenefitTemplate.tt/>

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Linq;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Mods.TechTree;
    using Eco.Shared.Items;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Shared.View;

    /// <summary>
    /// <para>Server side talent definition for "ParallelProcessing".</para>
    /// <para>More information about Talent objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.Talent.html</para>
    /// <remarks>
    /// This is an auto-generated class. Don't modify it! All your changes will be wiped with next update! Use Mods* partial methods instead for customization. 
    /// If you wish to modify this class, please create a new partial class or follow the instructions in the "UserCode" folder to override the entire file.
    /// </remarks>
    /// </summary>
    public partial class ParallelProcessingTalent : Talent
    {
        public override bool Base => true;
        public override Type TalentType { get { return typeof(CraftingTalent); } }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Composites")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class CompositesParallelProcessingTalentGroup : TalentGroup
    {
        public CompositesParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(CompositesParallelSpeedTalent),
            };
            this.OwningSkill = typeof(CompositesSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class CompositesParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(CompositesParallelProcessingTalentGroup); } }
        public CompositesParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: AdvancedBaking")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class AdvancedBakingParallelProcessingTalentGroup : TalentGroup
    {
        public AdvancedBakingParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(AdvancedBakingParallelSpeedTalent),
            };
            this.OwningSkill = typeof(AdvancedBakingSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class AdvancedBakingParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(AdvancedBakingParallelProcessingTalentGroup); } }
        public AdvancedBakingParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: CampfireCooking")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class CampfireCookingParallelProcessingTalentGroup : TalentGroup
    {
        public CampfireCookingParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(CampfireCookingParallelSpeedTalent),
            };
            this.OwningSkill = typeof(CampfireCookingSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class CampfireCookingParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(CampfireCookingParallelProcessingTalentGroup); } }
        public CampfireCookingParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: AdvancedCooking")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class AdvancedCookingParallelProcessingTalentGroup : TalentGroup
    {
        public AdvancedCookingParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(AdvancedCookingParallelSpeedTalent),
            };
            this.OwningSkill = typeof(AdvancedCookingSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class AdvancedCookingParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(AdvancedCookingParallelProcessingTalentGroup); } }
        public AdvancedCookingParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: AdvancedSmelting")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class AdvancedSmeltingParallelProcessingTalentGroup : TalentGroup
    {
        public AdvancedSmeltingParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(AdvancedSmeltingParallelSpeedTalent),
            };
            this.OwningSkill = typeof(AdvancedSmeltingSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class AdvancedSmeltingParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(AdvancedSmeltingParallelProcessingTalentGroup); } }
        public AdvancedSmeltingParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Baking")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class BakingParallelProcessingTalentGroup : TalentGroup
    {
        public BakingParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(BakingParallelSpeedTalent),
            };
            this.OwningSkill = typeof(BakingSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class BakingParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(BakingParallelProcessingTalentGroup); } }
        public BakingParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: BasicEngineering")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class BasicEngineeringParallelProcessingTalentGroup : TalentGroup
    {
        public BasicEngineeringParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(BasicEngineeringParallelSpeedTalent),
            };
            this.OwningSkill = typeof(BasicEngineeringSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class BasicEngineeringParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(BasicEngineeringParallelProcessingTalentGroup); } }
        public BasicEngineeringParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Pottery")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class PotteryParallelProcessingTalentGroup : TalentGroup
    {
        public PotteryParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(PotteryParallelSpeedTalent),
            };
            this.OwningSkill = typeof(PotterySkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class PotteryParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(PotteryParallelProcessingTalentGroup); } }
        public PotteryParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Butchery")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class ButcheryParallelProcessingTalentGroup : TalentGroup
    {
        public ButcheryParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(ButcheryParallelSpeedTalent),
            };
            this.OwningSkill = typeof(ButcherySkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class ButcheryParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(ButcheryParallelProcessingTalentGroup); } }
        public ButcheryParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: AdvancedMasonry")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class AdvancedMasonryParallelProcessingTalentGroup : TalentGroup
    {
        public AdvancedMasonryParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(AdvancedMasonryParallelSpeedTalent),
            };
            this.OwningSkill = typeof(AdvancedMasonrySkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class AdvancedMasonryParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(AdvancedMasonryParallelProcessingTalentGroup); } }
        public AdvancedMasonryParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Cooking")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class CookingParallelProcessingTalentGroup : TalentGroup
    {
        public CookingParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(CookingParallelSpeedTalent),
            };
            this.OwningSkill = typeof(CookingSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class CookingParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(CookingParallelProcessingTalentGroup); } }
        public CookingParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: CuttingEdgeCooking")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class CuttingEdgeCookingParallelProcessingTalentGroup : TalentGroup
    {
        public CuttingEdgeCookingParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(CuttingEdgeCookingParallelSpeedTalent),
            };
            this.OwningSkill = typeof(CuttingEdgeCookingSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class CuttingEdgeCookingParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(CuttingEdgeCookingParallelProcessingTalentGroup); } }
        public CuttingEdgeCookingParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Electronics")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class ElectronicsParallelProcessingTalentGroup : TalentGroup
    {
        public ElectronicsParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(ElectronicsParallelSpeedTalent),
            };
            this.OwningSkill = typeof(ElectronicsSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class ElectronicsParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(ElectronicsParallelProcessingTalentGroup); } }
        public ElectronicsParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Fertilizers")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class FertilizersParallelProcessingTalentGroup : TalentGroup
    {
        public FertilizersParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(FertilizersParallelSpeedTalent),
            };
            this.OwningSkill = typeof(FertilizersSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class FertilizersParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(FertilizersParallelProcessingTalentGroup); } }
        public FertilizersParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Glassworking")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class GlassworkingParallelProcessingTalentGroup : TalentGroup
    {
        public GlassworkingParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(GlassworkingParallelSpeedTalent),
            };
            this.OwningSkill = typeof(GlassworkingSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class GlassworkingParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(GlassworkingParallelProcessingTalentGroup); } }
        public GlassworkingParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Industry")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class IndustryParallelProcessingTalentGroup : TalentGroup
    {
        public IndustryParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(IndustryParallelSpeedTalent),
            };
            this.OwningSkill = typeof(IndustrySkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class IndustryParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(IndustryParallelProcessingTalentGroup); } }
        public IndustryParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Mechanics")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class MechanicsParallelProcessingTalentGroup : TalentGroup
    {
        public MechanicsParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(MechanicsParallelSpeedTalent),
            };
            this.OwningSkill = typeof(MechanicsSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class MechanicsParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(MechanicsParallelProcessingTalentGroup); } }
        public MechanicsParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Milling")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class MillingParallelProcessingTalentGroup : TalentGroup
    {
        public MillingParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(MillingParallelSpeedTalent),
            };
            this.OwningSkill = typeof(MillingSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class MillingParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(MillingParallelProcessingTalentGroup); } }
        public MillingParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Masonry")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class MasonryParallelProcessingTalentGroup : TalentGroup
    {
        public MasonryParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(MasonryParallelSpeedTalent),
            };
            this.OwningSkill = typeof(MasonrySkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class MasonryParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(MasonryParallelProcessingTalentGroup); } }
        public MasonryParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: OilDrilling")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class OilDrillingParallelProcessingTalentGroup : TalentGroup
    {
        public OilDrillingParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(OilDrillingParallelSpeedTalent),
            };
            this.OwningSkill = typeof(OilDrillingSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class OilDrillingParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(OilDrillingParallelProcessingTalentGroup); } }
        public OilDrillingParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: PaperMilling")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class PaperMillingParallelProcessingTalentGroup : TalentGroup
    {
        public PaperMillingParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(PaperMillingParallelSpeedTalent),
            };
            this.OwningSkill = typeof(PaperMillingSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class PaperMillingParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(PaperMillingParallelProcessingTalentGroup); } }
        public PaperMillingParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Smelting")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class SmeltingParallelProcessingTalentGroup : TalentGroup
    {
        public SmeltingParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(SmeltingParallelSpeedTalent),
            };
            this.OwningSkill = typeof(SmeltingSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class SmeltingParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(SmeltingParallelProcessingTalentGroup); } }
        public SmeltingParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Tailoring")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class TailoringParallelProcessingTalentGroup : TalentGroup
    {
        public TailoringParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(TailoringParallelSpeedTalent),
            };
            this.OwningSkill = typeof(TailoringSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class TailoringParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(TailoringParallelProcessingTalentGroup); } }
        public TailoringParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Farming")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class FarmingParallelProcessingTalentGroup : TalentGroup
    {
        public FarmingParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(FarmingParallelSpeedTalent),
            };
            this.OwningSkill = typeof(FarmingSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class FarmingParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(FarmingParallelProcessingTalentGroup); } }
        public FarmingParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Carpentry")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class CarpentryParallelProcessingTalentGroup : TalentGroup
    {
        public CarpentryParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(CarpentryParallelSpeedTalent),
            };
            this.OwningSkill = typeof(CarpentrySkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class CarpentryParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(CarpentryParallelProcessingTalentGroup); } }
        public CarpentryParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Shipwright")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class ShipwrightParallelProcessingTalentGroup : TalentGroup
    {
        public ShipwrightParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(ShipwrightParallelSpeedTalent),
            };
            this.OwningSkill = typeof(ShipwrightSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class ShipwrightParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(ShipwrightParallelProcessingTalentGroup); } }
        public ShipwrightParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Blacksmith")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class BlacksmithParallelProcessingTalentGroup : TalentGroup
    {
        public BlacksmithParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(BlacksmithParallelSpeedTalent),
            };
            this.OwningSkill = typeof(BlacksmithSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class BlacksmithParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(BlacksmithParallelProcessingTalentGroup); } }
        public BlacksmithParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }

    /// <summary>
    /// <para>Server side talent group definition for "ParallelProcessing".</para>
    /// <para>More information about TalentGroup objects can be found at https://docs.play.eco/api/server/eco.gameplay/Eco.Gameplay.Skills.TalentGroup.html</para>
    /// </summary>
    [Serialized]
    [LocDisplayName("Parallel Processing: Painting")]
    [LocDescription("Increases the crafting speed of identical tables when they share a room by 20 percent.")]
    public partial class PaintingParallelProcessingTalentGroup : TalentGroup
    {
        public PaintingParallelProcessingTalentGroup()
        {
            Talents = new Type[]
            {
                typeof(PaintingParallelSpeedTalent),
            };
            this.OwningSkill = typeof(PaintingSkill);
            this.Level = 3;
        }
    }

    [Serialized]
    public partial class PaintingParallelSpeedTalent : ParallelProcessingTalent
    {
        public override bool Base { get { return false; } }
        public override Type TalentGroupType { get { return typeof(PaintingParallelProcessingTalentGroup); } }
        public PaintingParallelSpeedTalent()
        {
            this.Value = 0.8f;
        }
    }
}
