﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated from BlockTemplate.tt/>

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Core.Items;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Shared.SharedTypes;
    using Eco.World;
    using Eco.World.Blocks;
    using Eco.World.Water;
    using Eco.Gameplay.Pipes;
    using Eco.Core.Controller;
    using Eco.Gameplay.Items.Recipes;
    using Eco.Shared.Graphics;
    using Eco.World.Color;

    /// <summary>Auto-generated class. Don't modify it! All your changes will be wiped with next update! Use Mods* partial methods instead for customization.</summary>

    [Serialized]
    [Solid, Wall, Cliff, Minable(2)]
        public partial class SulfurBlock :
        Block
        , IRepresentsItem
    {
        public virtual Type RepresentedItemType { get { return typeof(SulfurItem); } }
    }

    [Serialized]
    [LocDisplayName("Sulfur")]
    [LocDescription("While it may not look like much it is fundamentally essential to sustain life.")]
    [MaxStackSize(20)]
    [Weight(6500)]
    [ResourcePile]
    [StartsDiscovered]
    [Ecopedia("Natural Resources", "Stone", createAsSubPage: true)]
    [Tag("Excavatable")]
    public partial class SulfurItem :
 
    BlockItem<SulfurBlock>
    {
        public override LocString DisplayNamePlural { get { return Localizer.DoStr("Sulfur"); } }

        public override bool CanStickToWalls { get { return false; } }

        private static Type[] blockTypes = new Type[] {
            typeof(SulfurStacked1Block),
            typeof(SulfurStacked2Block),
            typeof(SulfurStacked3Block),
            typeof(SulfurStacked4Block)
        };
        
        public override Type[] BlockTypes { get { return blockTypes; } }
    }

    [Tag("Excavatable")]
    [Tag(BlockTags.PartialStack)]
    [Serialized, Solid] public class SulfurStacked1Block : PickupableBlock, IWaterLoggedBlock { }
    [Tag("Excavatable")]
    [Tag(BlockTags.PartialStack)]
    [Serialized, Solid] public class SulfurStacked2Block : PickupableBlock, IWaterLoggedBlock { }
    [Tag("Excavatable")]
    [Tag(BlockTags.PartialStack)]
    [Serialized, Solid] public class SulfurStacked3Block : PickupableBlock, IWaterLoggedBlock { }
    [Tag("Excavatable")]
    [Tag(BlockTags.FullStack)]
    [Serialized, Solid,Wall] public class SulfurStacked4Block : PickupableBlock, IWaterLoggedBlock { } //Only a wall if it's all 4 Sulfur
}
