﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated from FormsTemplate.tt/>

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.World;
    using Eco.World.Water;
    using Eco.World.Blocks;
    using Eco.Gameplay.Pipes;
    using Tag = Eco.Core.Items.TagAttribute;
    using Eco.World.Color;

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(FloorFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFloorBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(AshlarLimestoneItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(FullWallFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFullWallBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(AshlarLimestoneItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(FlatRoofFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFlatRoofBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(AshlarLimestoneItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(CubeFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneCubeBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(AshlarLimestoneItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RoofCubeFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofCubeBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(AshlarLimestoneItem); } }
    }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(ChimneyFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneChimneyBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(AshlarLimestoneItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(WallFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneWallBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(AshlarLimestoneItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(ColumnFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneColumnBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(AshlarLimestoneItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(WindowFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneWindowBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(AshlarLimestoneItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(FenceFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFenceBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(AshlarLimestoneItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(DoubleWindowFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneDoubleWindowBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(AshlarLimestoneItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderPeakSetFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderPeakSetBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(AshlarLimestoneItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(PeakSetFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestonePeakSetBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(AshlarLimestoneItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RoofPeakSetFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofPeakSetBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(AshlarLimestoneItem); } }
    }





    [RotatedVariants(typeof(AshlarLimestoneRampABlock), typeof(AshlarLimestoneRampA90Block), typeof(AshlarLimestoneRampA180Block), typeof(AshlarLimestoneRampA270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RampAFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampABlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampA90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampA180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampA270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneRampBBlock), typeof(AshlarLimestoneRampB90Block), typeof(AshlarLimestoneRampB180Block), typeof(AshlarLimestoneRampB270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RampBFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampBBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampB90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampB180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampB270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneRampCBlock), typeof(AshlarLimestoneRampC90Block), typeof(AshlarLimestoneRampC180Block), typeof(AshlarLimestoneRampC270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RampCFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampCBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampC90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampC180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampC270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneRampDBlock), typeof(AshlarLimestoneRampD90Block), typeof(AshlarLimestoneRampD180Block), typeof(AshlarLimestoneRampD270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RampDFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampDBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampD90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampD180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRampD270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneLadderBlock), typeof(AshlarLimestoneLadder90Block), typeof(AshlarLimestoneLadder180Block), typeof(AshlarLimestoneLadder270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(LadderFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneLadderBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneLadder90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneLadder180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneLadder270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneStairsBlock), typeof(AshlarLimestoneStairs90Block), typeof(AshlarLimestoneStairs180Block), typeof(AshlarLimestoneStairs270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(StairsFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneStairsBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneStairs90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneStairs180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneStairs270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneUnderStairsBlock), typeof(AshlarLimestoneUnderStairs90Block), typeof(AshlarLimestoneUnderStairs180Block), typeof(AshlarLimestoneUnderStairs270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderStairsFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderStairsBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderStairs90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderStairs180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderStairs270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneFloatStairsBlock), typeof(AshlarLimestoneFloatStairs90Block), typeof(AshlarLimestoneFloatStairs180Block), typeof(AshlarLimestoneFloatStairs270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(FloatStairsFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFloatStairsBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFloatStairs90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFloatStairs180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFloatStairs270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneBraceBlock), typeof(AshlarLimestoneBrace90Block), typeof(AshlarLimestoneBrace180Block), typeof(AshlarLimestoneBrace270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(BraceFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBraceBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBrace90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBrace180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBrace270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneUnderBraceBlock), typeof(AshlarLimestoneUnderBrace90Block), typeof(AshlarLimestoneUnderBrace180Block), typeof(AshlarLimestoneUnderBrace270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderBraceFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderBraceBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderBrace90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderBrace180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderBrace270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneSideBraceBlock), typeof(AshlarLimestoneSideBrace90Block), typeof(AshlarLimestoneSideBrace180Block), typeof(AshlarLimestoneSideBrace270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(SideBraceFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneSideBraceBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneSideBrace90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneSideBrace180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneSideBrace270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneBasicSlopeSideBlock), typeof(AshlarLimestoneBasicSlopeSide90Block), typeof(AshlarLimestoneBasicSlopeSide180Block), typeof(AshlarLimestoneBasicSlopeSide270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(BasicSlopeSideFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopeSideBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopeSide90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopeSide180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopeSide270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneBasicSlopeCornerBlock), typeof(AshlarLimestoneBasicSlopeCorner90Block), typeof(AshlarLimestoneBasicSlopeCorner180Block), typeof(AshlarLimestoneBasicSlopeCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(BasicSlopeCornerFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopeCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopeCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopeCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopeCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneBasicSlopeTurnBlock), typeof(AshlarLimestoneBasicSlopeTurn90Block), typeof(AshlarLimestoneBasicSlopeTurn180Block), typeof(AshlarLimestoneBasicSlopeTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(BasicSlopeTurnFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopeTurnBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopeTurn90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopeTurn180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopeTurn270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneBasicSlopePointBlock), typeof(AshlarLimestoneBasicSlopePoint90Block), typeof(AshlarLimestoneBasicSlopePoint180Block), typeof(AshlarLimestoneBasicSlopePoint270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(BasicSlopePointFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopePointBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopePoint90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopePoint180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBasicSlopePoint270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneFloatStairsCornerBlock), typeof(AshlarLimestoneFloatStairsCorner90Block), typeof(AshlarLimestoneFloatStairsCorner180Block), typeof(AshlarLimestoneFloatStairsCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(FloatStairsCornerFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFloatStairsCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFloatStairsCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFloatStairsCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFloatStairsCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneFloatStairsTurnBlock), typeof(AshlarLimestoneFloatStairsTurn90Block), typeof(AshlarLimestoneFloatStairsTurn180Block), typeof(AshlarLimestoneFloatStairsTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(FloatStairsTurnFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFloatStairsTurnBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFloatStairsTurn90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFloatStairsTurn180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneFloatStairsTurn270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneStairsCornerBlock), typeof(AshlarLimestoneStairsCorner90Block), typeof(AshlarLimestoneStairsCorner180Block), typeof(AshlarLimestoneStairsCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(StairsCornerFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneStairsCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneStairsCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneStairsCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneStairsCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneStairsTurnBlock), typeof(AshlarLimestoneStairsTurn90Block), typeof(AshlarLimestoneStairsTurn180Block), typeof(AshlarLimestoneStairsTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(StairsTurnFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneStairsTurnBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneStairsTurn90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneStairsTurn180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneStairsTurn270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneUnderBraceCornerBlock), typeof(AshlarLimestoneUnderBraceCorner90Block), typeof(AshlarLimestoneUnderBraceCorner180Block), typeof(AshlarLimestoneUnderBraceCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderBraceCornerFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderBraceCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderBraceCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderBraceCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderBraceCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneBraceCornerBlock), typeof(AshlarLimestoneBraceCorner90Block), typeof(AshlarLimestoneBraceCorner180Block), typeof(AshlarLimestoneBraceCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(BraceCornerFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBraceCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBraceCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBraceCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBraceCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneUnderSlopeSideBlock), typeof(AshlarLimestoneUnderSlopeSide90Block), typeof(AshlarLimestoneUnderSlopeSide180Block), typeof(AshlarLimestoneUnderSlopeSide270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderSlopeSideFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopeSideBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopeSide90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopeSide180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopeSide270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneUnderSlopeCornerBlock), typeof(AshlarLimestoneUnderSlopeCorner90Block), typeof(AshlarLimestoneUnderSlopeCorner180Block), typeof(AshlarLimestoneUnderSlopeCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderSlopeCornerFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopeCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopeCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopeCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopeCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneUnderSlopeTurnBlock), typeof(AshlarLimestoneUnderSlopeTurn90Block), typeof(AshlarLimestoneUnderSlopeTurn180Block), typeof(AshlarLimestoneUnderSlopeTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderSlopeTurnFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopeTurnBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopeTurn90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopeTurn180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopeTurn270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneUnderSlopePeakBlock), typeof(AshlarLimestoneUnderSlopePeak90Block), typeof(AshlarLimestoneUnderSlopePeak180Block), typeof(AshlarLimestoneUnderSlopePeak270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderSlopePeakFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopePeakBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopePeak90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopePeak180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderSlopePeak270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneRoofSideBlock), typeof(AshlarLimestoneRoofSide90Block), typeof(AshlarLimestoneRoofSide180Block), typeof(AshlarLimestoneRoofSide270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RoofSideFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofSideBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofSide90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofSide180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofSide270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneRoofTurnBlock), typeof(AshlarLimestoneRoofTurn90Block), typeof(AshlarLimestoneRoofTurn180Block), typeof(AshlarLimestoneRoofTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RoofTurnFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofTurnBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofTurn90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofTurn180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofTurn270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneRoofCornerBlock), typeof(AshlarLimestoneRoofCorner90Block), typeof(AshlarLimestoneRoofCorner180Block), typeof(AshlarLimestoneRoofCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RoofCornerFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneRoofPeakBlock), typeof(AshlarLimestoneRoofPeak90Block), typeof(AshlarLimestoneRoofPeak180Block), typeof(AshlarLimestoneRoofPeak270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RoofPeakFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofPeakBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofPeak90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofPeak180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneRoofPeak270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneUnderInnerPeakBlock), typeof(AshlarLimestoneUnderInnerPeak90Block), typeof(AshlarLimestoneUnderInnerPeak180Block), typeof(AshlarLimestoneUnderInnerPeak270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderInnerPeakFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderInnerPeakBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderInnerPeak90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderInnerPeak180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderInnerPeak270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneBraceTurnBlock), typeof(AshlarLimestoneBraceTurn90Block), typeof(AshlarLimestoneBraceTurn180Block), typeof(AshlarLimestoneBraceTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(BraceTurnFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBraceTurnBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBraceTurn90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBraceTurn180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneBraceTurn270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneUnderBraceTurnBlock), typeof(AshlarLimestoneUnderBraceTurn90Block), typeof(AshlarLimestoneUnderBraceTurn180Block), typeof(AshlarLimestoneUnderBraceTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderBraceTurnFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderBraceTurnBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderBraceTurn90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderBraceTurn180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneUnderBraceTurn270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneHalfSlopeABlock), typeof(AshlarLimestoneHalfSlopeA90Block), typeof(AshlarLimestoneHalfSlopeA180Block), typeof(AshlarLimestoneHalfSlopeA270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(HalfSlopeAFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneHalfSlopeABlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneHalfSlopeA90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneHalfSlopeA180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneHalfSlopeA270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(AshlarLimestoneHalfSlopeBBlock), typeof(AshlarLimestoneHalfSlopeB90Block), typeof(AshlarLimestoneHalfSlopeB180Block), typeof(AshlarLimestoneHalfSlopeB270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(HalfSlopeBFormType), typeof(AshlarLimestoneItem))]
    [Tag("Constructable")]
    public partial class AshlarLimestoneHalfSlopeBBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneHalfSlopeB90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneHalfSlopeB180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class AshlarLimestoneHalfSlopeB270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

}