﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated from FormsTemplate.tt/>

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.World;
    using Eco.World.Water;
    using Eco.World.Blocks;
    using Eco.Gameplay.Pipes;
    using Tag = Eco.Core.Items.TagAttribute;
    using Eco.World.Color;

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(FloorFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberFloorBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(FullWallFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberFullWallBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(FlatRoofFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberFlatRoofBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RoofCubeFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofCubeBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(CubeFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberCubeBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(WindowWallFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberWindowWallBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(CladWallFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberCladWallBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(WallFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberWallBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(WallTrimFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberWallTrimBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(ColumnFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberColumnBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(ThinColumnFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberThinColumnBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(WindowFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberWindowBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(WindowGrillesFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberWindowGrillesBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(DoubleWindowFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberDoubleWindowBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(FenceFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberFenceBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(SideFenceFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberSideFenceBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderPeakSetFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderPeakSetBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(PeakSetFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberPeakSetBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RoofPeakSetFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofPeakSetBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(CompositeLumberItem); } }
    }





    [RotatedVariants(typeof(CompositeLumberRampABlock), typeof(CompositeLumberRampA90Block), typeof(CompositeLumberRampA180Block), typeof(CompositeLumberRampA270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RampAFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberRampABlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRampA90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRampA180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRampA270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberRampBBlock), typeof(CompositeLumberRampB90Block), typeof(CompositeLumberRampB180Block), typeof(CompositeLumberRampB270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RampBFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberRampBBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRampB90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRampB180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRampB270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberRampCBlock), typeof(CompositeLumberRampC90Block), typeof(CompositeLumberRampC180Block), typeof(CompositeLumberRampC270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RampCFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberRampCBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRampC90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRampC180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRampC270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberRampDBlock), typeof(CompositeLumberRampD90Block), typeof(CompositeLumberRampD180Block), typeof(CompositeLumberRampD270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RampDFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberRampDBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRampD90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRampD180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRampD270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberLadderBlock), typeof(CompositeLumberLadder90Block), typeof(CompositeLumberLadder180Block), typeof(CompositeLumberLadder270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(LadderFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberLadderBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberLadder90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberLadder180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberLadder270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberStairsBlock), typeof(CompositeLumberStairs90Block), typeof(CompositeLumberStairs180Block), typeof(CompositeLumberStairs270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(StairsFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberStairsBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberStairs90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberStairs180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberStairs270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberUnderStairsBlock), typeof(CompositeLumberUnderStairs90Block), typeof(CompositeLumberUnderStairs180Block), typeof(CompositeLumberUnderStairs270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderStairsFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderStairsBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderStairs90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderStairs180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderStairs270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberFloatStairsBlock), typeof(CompositeLumberFloatStairs90Block), typeof(CompositeLumberFloatStairs180Block), typeof(CompositeLumberFloatStairs270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(FloatStairsFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberFloatStairsBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberFloatStairs90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberFloatStairs180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberFloatStairs270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberBraceBlock), typeof(CompositeLumberBrace90Block), typeof(CompositeLumberBrace180Block), typeof(CompositeLumberBrace270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(BraceFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberBraceBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBrace90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBrace180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBrace270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberUnderBraceBlock), typeof(CompositeLumberUnderBrace90Block), typeof(CompositeLumberUnderBrace180Block), typeof(CompositeLumberUnderBrace270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderBraceFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderBraceBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderBrace90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderBrace180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderBrace270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberSideBraceBlock), typeof(CompositeLumberSideBrace90Block), typeof(CompositeLumberSideBrace180Block), typeof(CompositeLumberSideBrace270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(SideBraceFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberSideBraceBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberSideBrace90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberSideBrace180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberSideBrace270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberBasicSlopeSideBlock), typeof(CompositeLumberBasicSlopeSide90Block), typeof(CompositeLumberBasicSlopeSide180Block), typeof(CompositeLumberBasicSlopeSide270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(BasicSlopeSideFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopeSideBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopeSide90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopeSide180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopeSide270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberBasicSlopeCornerBlock), typeof(CompositeLumberBasicSlopeCorner90Block), typeof(CompositeLumberBasicSlopeCorner180Block), typeof(CompositeLumberBasicSlopeCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(BasicSlopeCornerFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopeCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopeCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopeCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopeCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberBasicSlopeTurnBlock), typeof(CompositeLumberBasicSlopeTurn90Block), typeof(CompositeLumberBasicSlopeTurn180Block), typeof(CompositeLumberBasicSlopeTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(BasicSlopeTurnFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopeTurnBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopeTurn90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopeTurn180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopeTurn270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberBasicSlopePointBlock), typeof(CompositeLumberBasicSlopePoint90Block), typeof(CompositeLumberBasicSlopePoint180Block), typeof(CompositeLumberBasicSlopePoint270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(BasicSlopePointFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopePointBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopePoint90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopePoint180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberBasicSlopePoint270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberFloatStairsCornerBlock), typeof(CompositeLumberFloatStairsCorner90Block), typeof(CompositeLumberFloatStairsCorner180Block), typeof(CompositeLumberFloatStairsCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(FloatStairsCornerFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberFloatStairsCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberFloatStairsCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberFloatStairsCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberFloatStairsCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberFloatStairsTurnBlock), typeof(CompositeLumberFloatStairsTurn90Block), typeof(CompositeLumberFloatStairsTurn180Block), typeof(CompositeLumberFloatStairsTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(FloatStairsTurnFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberFloatStairsTurnBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberFloatStairsTurn90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberFloatStairsTurn180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberFloatStairsTurn270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberStairsCornerBlock), typeof(CompositeLumberStairsCorner90Block), typeof(CompositeLumberStairsCorner180Block), typeof(CompositeLumberStairsCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(StairsCornerFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberStairsCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberStairsCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberStairsCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberStairsCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberStairsTurnBlock), typeof(CompositeLumberStairsTurn90Block), typeof(CompositeLumberStairsTurn180Block), typeof(CompositeLumberStairsTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(StairsTurnFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberStairsTurnBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberStairsTurn90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberStairsTurn180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberStairsTurn270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberUnderSlopeSideBlock), typeof(CompositeLumberUnderSlopeSide90Block), typeof(CompositeLumberUnderSlopeSide180Block), typeof(CompositeLumberUnderSlopeSide270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderSlopeSideFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopeSideBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopeSide90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopeSide180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopeSide270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberUnderSlopeCornerBlock), typeof(CompositeLumberUnderSlopeCorner90Block), typeof(CompositeLumberUnderSlopeCorner180Block), typeof(CompositeLumberUnderSlopeCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderSlopeCornerFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopeCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopeCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopeCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopeCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberUnderSlopeTurnBlock), typeof(CompositeLumberUnderSlopeTurn90Block), typeof(CompositeLumberUnderSlopeTurn180Block), typeof(CompositeLumberUnderSlopeTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderSlopeTurnFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopeTurnBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopeTurn90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopeTurn180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopeTurn270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberUnderSlopePeakBlock), typeof(CompositeLumberUnderSlopePeak90Block), typeof(CompositeLumberUnderSlopePeak180Block), typeof(CompositeLumberUnderSlopePeak270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderSlopePeakFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopePeakBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopePeak90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopePeak180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderSlopePeak270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberRoofSideBlock), typeof(CompositeLumberRoofSide90Block), typeof(CompositeLumberRoofSide180Block), typeof(CompositeLumberRoofSide270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RoofSideFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofSideBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofSide90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofSide180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofSide270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberRoofTurnBlock), typeof(CompositeLumberRoofTurn90Block), typeof(CompositeLumberRoofTurn180Block), typeof(CompositeLumberRoofTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RoofTurnFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofTurnBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofTurn90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofTurn180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofTurn270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberRoofCornerBlock), typeof(CompositeLumberRoofCorner90Block), typeof(CompositeLumberRoofCorner180Block), typeof(CompositeLumberRoofCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RoofCornerFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberRoofPeakBlock), typeof(CompositeLumberRoofPeak90Block), typeof(CompositeLumberRoofPeak180Block), typeof(CompositeLumberRoofPeak270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(RoofPeakFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofPeakBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofPeak90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofPeak180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberRoofPeak270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(CompositeLumberUnderInnerPeakBlock), typeof(CompositeLumberUnderInnerPeak90Block), typeof(CompositeLumberUnderInnerPeak180Block), typeof(CompositeLumberUnderInnerPeak270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [IsForm(typeof(UnderInnerPeakFormType), typeof(CompositeLumberItem))]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderInnerPeakBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderInnerPeak90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderInnerPeak180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(5)]
    [Tag("Constructable")]
    public partial class CompositeLumberUnderInnerPeak270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

}