﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated from FormsTemplate.tt/>

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.World;
    using Eco.World.Water;
    using Eco.World.Blocks;
    using Eco.Gameplay.Pipes;
    using Tag = Eco.Core.Items.TagAttribute;
    using Eco.World.Color;

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(FloorFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberFloorBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(FarEastLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(CeilingFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberCeilingBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(FarEastLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(CubeFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberCubeBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(FarEastLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(ColumnFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberColumnBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(FarEastLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(WallX_01FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWallX_01Block :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(FarEastLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(WallX_02FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWallX_02Block :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(FarEastLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(WallX_03FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWallX_03Block :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(FarEastLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(WallX_04FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWallX_04Block :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(FarEastLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Column_01FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberColumn_01Block :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(FarEastLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Column_02FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberColumn_02Block :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(FarEastLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Column_03FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberColumn_03Block :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(FarEastLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(FenceXFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceXBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(FarEastLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(RoofPeakXFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofPeakXBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(FarEastLumberItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(RoofCubeFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofCubeBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(FarEastLumberItem); } }
    }





    [RotatedVariants(typeof(FarEastLumberWall_01Block), typeof(FarEastLumberWall_0190Block), typeof(FarEastLumberWall_01180Block), typeof(FarEastLumberWall_01270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_01FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_01Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_0190Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_01180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_01270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_02Block), typeof(FarEastLumberWall_0290Block), typeof(FarEastLumberWall_02180Block), typeof(FarEastLumberWall_02270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_02FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_02Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_0290Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_02180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_02270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_03Block), typeof(FarEastLumberWall_0390Block), typeof(FarEastLumberWall_03180Block), typeof(FarEastLumberWall_03270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_03FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_03Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_0390Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_03180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_03270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_04Block), typeof(FarEastLumberWall_0490Block), typeof(FarEastLumberWall_04180Block), typeof(FarEastLumberWall_04270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_04FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_04Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_0490Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_04180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_04270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_05Block), typeof(FarEastLumberWall_0590Block), typeof(FarEastLumberWall_05180Block), typeof(FarEastLumberWall_05270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_05FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_05Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_0590Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_05180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_05270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_06Block), typeof(FarEastLumberWall_0690Block), typeof(FarEastLumberWall_06180Block), typeof(FarEastLumberWall_06270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_06FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_06Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_0690Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_06180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_06270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_07Block), typeof(FarEastLumberWall_0790Block), typeof(FarEastLumberWall_07180Block), typeof(FarEastLumberWall_07270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_07FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_07Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_0790Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_07180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_07270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_08Block), typeof(FarEastLumberWall_0890Block), typeof(FarEastLumberWall_08180Block), typeof(FarEastLumberWall_08270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_08FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_08Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_0890Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_08180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_08270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_09Block), typeof(FarEastLumberWall_0990Block), typeof(FarEastLumberWall_09180Block), typeof(FarEastLumberWall_09270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_09FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_09Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_0990Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_09180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_09270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_10Block), typeof(FarEastLumberWall_1090Block), typeof(FarEastLumberWall_10180Block), typeof(FarEastLumberWall_10270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_10FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_10Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_1090Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_10180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_10270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_11Block), typeof(FarEastLumberWall_1190Block), typeof(FarEastLumberWall_11180Block), typeof(FarEastLumberWall_11270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_11FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_11Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_1190Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_11180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_11270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_12Block), typeof(FarEastLumberWall_1290Block), typeof(FarEastLumberWall_12180Block), typeof(FarEastLumberWall_12270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_12FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_12Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_1290Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_12180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_12270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_13Block), typeof(FarEastLumberWall_1390Block), typeof(FarEastLumberWall_13180Block), typeof(FarEastLumberWall_13270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_13FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_13Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_1390Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_13180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_13270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_14Block), typeof(FarEastLumberWall_1490Block), typeof(FarEastLumberWall_14180Block), typeof(FarEastLumberWall_14270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_14FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_14Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_1490Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_14180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_14270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_15Block), typeof(FarEastLumberWall_1590Block), typeof(FarEastLumberWall_15180Block), typeof(FarEastLumberWall_15270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_15FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_15Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_1590Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_15180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_15270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_16Block), typeof(FarEastLumberWall_1690Block), typeof(FarEastLumberWall_16180Block), typeof(FarEastLumberWall_16270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_16FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_16Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_1690Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_16180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_16270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_17Block), typeof(FarEastLumberWall_1790Block), typeof(FarEastLumberWall_17180Block), typeof(FarEastLumberWall_17270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_17FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_17Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_1790Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_17180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_17270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_18Block), typeof(FarEastLumberWall_1890Block), typeof(FarEastLumberWall_18180Block), typeof(FarEastLumberWall_18270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_18FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_18Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_1890Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_18180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_18270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWall_19Block), typeof(FarEastLumberWall_1990Block), typeof(FarEastLumberWall_19180Block), typeof(FarEastLumberWall_19270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(Wall_19FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_19Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_1990Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_19180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWall_19270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWallCorner_01Block), typeof(FarEastLumberWallCorner_0190Block), typeof(FarEastLumberWallCorner_01180Block), typeof(FarEastLumberWallCorner_01270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(WallCorner_01FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_01Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_0190Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_01180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_01270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWallCorner_02Block), typeof(FarEastLumberWallCorner_0290Block), typeof(FarEastLumberWallCorner_02180Block), typeof(FarEastLumberWallCorner_02270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(WallCorner_02FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_02Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_0290Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_02180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_02270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWallCorner_03Block), typeof(FarEastLumberWallCorner_0390Block), typeof(FarEastLumberWallCorner_03180Block), typeof(FarEastLumberWallCorner_03270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(WallCorner_03FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_03Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_0390Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_03180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_03270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWallCorner_04Block), typeof(FarEastLumberWallCorner_0490Block), typeof(FarEastLumberWallCorner_04180Block), typeof(FarEastLumberWallCorner_04270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(WallCorner_04FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_04Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_0490Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_04180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallCorner_04270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWallT_01Block), typeof(FarEastLumberWallT_0190Block), typeof(FarEastLumberWallT_01180Block), typeof(FarEastLumberWallT_01270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(WallT_01FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_01Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_0190Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_01180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_01270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWallT_02Block), typeof(FarEastLumberWallT_0290Block), typeof(FarEastLumberWallT_02180Block), typeof(FarEastLumberWallT_02270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(WallT_02FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_02Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_0290Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_02180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_02270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWallT_03Block), typeof(FarEastLumberWallT_0390Block), typeof(FarEastLumberWallT_03180Block), typeof(FarEastLumberWallT_03270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(WallT_03FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_03Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_0390Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_03180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_03270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWallT_04Block), typeof(FarEastLumberWallT_0490Block), typeof(FarEastLumberWallT_04180Block), typeof(FarEastLumberWallT_04270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(WallT_04FormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_04Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_0490Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_04180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWallT_04270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWindowBlock), typeof(FarEastLumberWindow90Block), typeof(FarEastLumberWindow180Block), typeof(FarEastLumberWindow270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(WindowFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWindowBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWindow90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWindow180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWindow270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberWindowGrillesBlock), typeof(FarEastLumberWindowGrilles90Block), typeof(FarEastLumberWindowGrilles180Block), typeof(FarEastLumberWindowGrilles270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(WindowGrillesFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberWindowGrillesBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWindowGrilles90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWindowGrilles180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberWindowGrilles270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberFenceMidBlock), typeof(FarEastLumberFenceMid90Block), typeof(FarEastLumberFenceMid180Block), typeof(FarEastLumberFenceMid270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(FenceMidFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceMidBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceMid90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceMid180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceMid270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberFenceCornerBlock), typeof(FarEastLumberFenceCorner90Block), typeof(FarEastLumberFenceCorner180Block), typeof(FarEastLumberFenceCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(FenceCornerFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceCornerBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceCorner90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceCorner180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceCorner270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberFenceTBlock), typeof(FarEastLumberFenceT90Block), typeof(FarEastLumberFenceT180Block), typeof(FarEastLumberFenceT270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(FenceTFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceTBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceT90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceT180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceT270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberFenceSoloBlock), typeof(FarEastLumberFenceSolo90Block), typeof(FarEastLumberFenceSolo180Block), typeof(FarEastLumberFenceSolo270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(FenceSoloFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceSoloBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceSolo90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceSolo180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceSolo270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberFenceEndBlock), typeof(FarEastLumberFenceEnd90Block), typeof(FarEastLumberFenceEnd180Block), typeof(FarEastLumberFenceEnd270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(FenceEndFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceEndBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceEnd90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceEnd180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberFenceEnd270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberRoofPeakBlock), typeof(FarEastLumberRoofPeak90Block), typeof(FarEastLumberRoofPeak180Block), typeof(FarEastLumberRoofPeak270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(RoofPeakFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofPeakBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofPeak90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofPeak180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofPeak270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberRoofCornerBlock), typeof(FarEastLumberRoofCorner90Block), typeof(FarEastLumberRoofCorner180Block), typeof(FarEastLumberRoofCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(RoofCornerFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofCornerBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofCorner90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofCorner180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofCorner270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberRoofTurnBlock), typeof(FarEastLumberRoofTurn90Block), typeof(FarEastLumberRoofTurn180Block), typeof(FarEastLumberRoofTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(RoofTurnFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofTurnBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofTurn90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofTurn180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofTurn270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberRoofSideBlock), typeof(FarEastLumberRoofSide90Block), typeof(FarEastLumberRoofSide180Block), typeof(FarEastLumberRoofSide270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(RoofSideFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofSideBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofSide90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofSide180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofSide270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberRoofPeakTBlock), typeof(FarEastLumberRoofPeakT90Block), typeof(FarEastLumberRoofPeakT180Block), typeof(FarEastLumberRoofPeakT270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(RoofPeakTFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofPeakTBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofPeakT90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofPeakT180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofPeakT270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberRoofPeakCornerBlock), typeof(FarEastLumberRoofPeakCorner90Block), typeof(FarEastLumberRoofPeakCorner180Block), typeof(FarEastLumberRoofPeakCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(RoofPeakCornerFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofPeakCornerBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofPeakCorner90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofPeakCorner180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofPeakCorner270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberRoofEdgeCornerBlock), typeof(FarEastLumberRoofEdgeCorner90Block), typeof(FarEastLumberRoofEdgeCorner180Block), typeof(FarEastLumberRoofEdgeCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(RoofEdgeCornerFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofEdgeCornerBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofEdgeCorner90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofEdgeCorner180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofEdgeCorner270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberRoofEdgeSideBlock), typeof(FarEastLumberRoofEdgeSide90Block), typeof(FarEastLumberRoofEdgeSide180Block), typeof(FarEastLumberRoofEdgeSide270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(RoofEdgeSideFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofEdgeSideBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofEdgeSide90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofEdgeSide180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofEdgeSide270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberRoofEdgeTurnBlock), typeof(FarEastLumberRoofEdgeTurn90Block), typeof(FarEastLumberRoofEdgeTurn180Block), typeof(FarEastLumberRoofEdgeTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(RoofEdgeTurnFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofEdgeTurnBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofEdgeTurn90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofEdgeTurn180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofEdgeTurn270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberRoofUnderslopeCornerBlock), typeof(FarEastLumberRoofUnderslopeCorner90Block), typeof(FarEastLumberRoofUnderslopeCorner180Block), typeof(FarEastLumberRoofUnderslopeCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(RoofUnderslopeCornerFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofUnderslopeCornerBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofUnderslopeCorner90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofUnderslopeCorner180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofUnderslopeCorner270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberRoofUnderslopeSideBlock), typeof(FarEastLumberRoofUnderslopeSide90Block), typeof(FarEastLumberRoofUnderslopeSide180Block), typeof(FarEastLumberRoofUnderslopeSide270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(RoofUnderslopeSideFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofUnderslopeSideBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofUnderslopeSide90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofUnderslopeSide180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofUnderslopeSide270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberRoofUnderslopeTurnBlock), typeof(FarEastLumberRoofUnderslopeTurn90Block), typeof(FarEastLumberRoofUnderslopeTurn180Block), typeof(FarEastLumberRoofUnderslopeTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(RoofUnderslopeTurnFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofUnderslopeTurnBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofUnderslopeTurn90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofUnderslopeTurn180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberRoofUnderslopeTurn270Block : Block, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberUnderInnerPeakBlock), typeof(FarEastLumberUnderInnerPeak90Block), typeof(FarEastLumberUnderInnerPeak180Block), typeof(FarEastLumberUnderInnerPeak270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(UnderInnerPeakFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberUnderInnerPeakBlock : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberUnderInnerPeak90Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberUnderInnerPeak180Block : Block, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberUnderInnerPeak270Block : Block, IColoredBlock
    { }

    [RotatedVariants(typeof(FarEastLumberStairsCornerBlock), typeof(FarEastLumberStairsCorner90Block), typeof(FarEastLumberStairsCorner180Block), typeof(FarEastLumberStairsCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(StairsCornerFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberStairsTurnBlock), typeof(FarEastLumberStairsTurn90Block), typeof(FarEastLumberStairsTurn180Block), typeof(FarEastLumberStairsTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(StairsTurnFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsTurnBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsTurn90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsTurn180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsTurn270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberStairsEndLeftBlock), typeof(FarEastLumberStairsEndLeft90Block), typeof(FarEastLumberStairsEndLeft180Block), typeof(FarEastLumberStairsEndLeft270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(StairsEndLeftFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsEndLeftBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsEndLeft90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsEndLeft180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsEndLeft270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberStairsEndRightBlock), typeof(FarEastLumberStairsEndRight90Block), typeof(FarEastLumberStairsEndRight180Block), typeof(FarEastLumberStairsEndRight270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(StairsEndRightFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsEndRightBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsEndRight90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsEndRight180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsEndRight270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberStairsMidBlock), typeof(FarEastLumberStairsMid90Block), typeof(FarEastLumberStairsMid180Block), typeof(FarEastLumberStairsMid270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(StairsMidFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsMidBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsMid90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsMid180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberStairsMid270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(FarEastLumberLadderBlock), typeof(FarEastLumberLadder90Block), typeof(FarEastLumberLadder180Block), typeof(FarEastLumberLadder270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [IsForm(typeof(LadderFormType), typeof(FarEastLumberItem))]
    [Tag("Constructable")]
    public partial class FarEastLumberLadderBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberLadder90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberLadder180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(3)]
    [Tag("Constructable")]
    public partial class FarEastLumberLadder270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

}