﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated from FormsTemplate.tt/>

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.World;
    using Eco.World.Water;
    using Eco.World.Blocks;
    using Eco.Gameplay.Pipes;
    using Tag = Eco.Core.Items.TagAttribute;
    using Eco.World.Color;

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(FloorFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogFloorBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(SoftwoodHewnLogItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(CubeFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogCubeBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(SoftwoodHewnLogItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(RoofCubeFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofCubeBlock :
        Block, IRepresentsItem, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(SoftwoodHewnLogItem); } }
    }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(WallFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogWallBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(SoftwoodHewnLogItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(RoofFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(SoftwoodHewnLogItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(ColumnFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogColumnBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(SoftwoodHewnLogItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(WindowGrillesFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogWindowGrillesBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(SoftwoodHewnLogItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(RoofPeakSetFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofPeakSetBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(SoftwoodHewnLogItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksFenceXFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceXBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(SoftwoodHewnLogItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksColumnFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksColumnBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(SoftwoodHewnLogItem); } }
    }
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksPillarBeamXFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamXBlock :
        Block, IRepresentsItem, IWaterLoggedBlock, IColoredBlock
    {
        public Type RepresentedItemType { get { return typeof(SoftwoodHewnLogItem); } }
    }





    [RotatedVariants(typeof(SoftwoodHewnLogStairsBlock), typeof(SoftwoodHewnLogStairs90Block), typeof(SoftwoodHewnLogStairs180Block), typeof(SoftwoodHewnLogStairs270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(StairsFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogStairsBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogStairs90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogStairs180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogStairs270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogLadderBlock), typeof(SoftwoodHewnLogLadder90Block), typeof(SoftwoodHewnLogLadder180Block), typeof(SoftwoodHewnLogLadder270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(LadderFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogLadderBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogLadder90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogLadder180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogLadder270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogRoofSideBlock), typeof(SoftwoodHewnLogRoofSide90Block), typeof(SoftwoodHewnLogRoofSide180Block), typeof(SoftwoodHewnLogRoofSide270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(RoofSideFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofSideBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofSide90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofSide180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofSide270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogRoofTurnBlock), typeof(SoftwoodHewnLogRoofTurn90Block), typeof(SoftwoodHewnLogRoofTurn180Block), typeof(SoftwoodHewnLogRoofTurn270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(RoofTurnFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofTurnBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofTurn90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofTurn180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofTurn270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogRoofCornerBlock), typeof(SoftwoodHewnLogRoofCorner90Block), typeof(SoftwoodHewnLogRoofCorner180Block), typeof(SoftwoodHewnLogRoofCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(RoofCornerFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogRoofPeakBlock), typeof(SoftwoodHewnLogRoofPeak90Block), typeof(SoftwoodHewnLogRoofPeak180Block), typeof(SoftwoodHewnLogRoofPeak270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(RoofPeakFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofPeakBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofPeak90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofPeak180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogRoofPeak270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksPillarBlock), typeof(SoftwoodHewnLogDocksPillar90Block), typeof(SoftwoodHewnLogDocksPillar180Block), typeof(SoftwoodHewnLogDocksPillar270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksPillarFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillar90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillar180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillar270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksRampsBlock), typeof(SoftwoodHewnLogDocksRamps90Block), typeof(SoftwoodHewnLogDocksRamps180Block), typeof(SoftwoodHewnLogDocksRamps270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksRampsFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampsBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRamps90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRamps180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRamps270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksPlatformBlock), typeof(SoftwoodHewnLogDocksPlatform90Block), typeof(SoftwoodHewnLogDocksPlatform180Block), typeof(SoftwoodHewnLogDocksPlatform270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksPlatformFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPlatformBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPlatform90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPlatform180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPlatform270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksPlatformFillBlock), typeof(SoftwoodHewnLogDocksPlatformFill90Block), typeof(SoftwoodHewnLogDocksPlatformFill180Block), typeof(SoftwoodHewnLogDocksPlatformFill270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksPlatformFillFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPlatformFillBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPlatformFill90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPlatformFill180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPlatformFill270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksPillarBeamBlock), typeof(SoftwoodHewnLogDocksPillarBeam90Block), typeof(SoftwoodHewnLogDocksPillarBeam180Block), typeof(SoftwoodHewnLogDocksPillarBeam270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksPillarBeamFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeam90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeam180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeam270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksFenceCornerBlock), typeof(SoftwoodHewnLogDocksFenceCorner90Block), typeof(SoftwoodHewnLogDocksFenceCorner180Block), typeof(SoftwoodHewnLogDocksFenceCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksFenceCornerFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksFenceMidBlock), typeof(SoftwoodHewnLogDocksFenceMid90Block), typeof(SoftwoodHewnLogDocksFenceMid180Block), typeof(SoftwoodHewnLogDocksFenceMid270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksFenceMidFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceMidBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceMid90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceMid180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceMid270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksFenceTBlock), typeof(SoftwoodHewnLogDocksFenceT90Block), typeof(SoftwoodHewnLogDocksFenceT180Block), typeof(SoftwoodHewnLogDocksFenceT270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksFenceTFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceTBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceT90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceT180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceT270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksPillarBeamEndBlock), typeof(SoftwoodHewnLogDocksPillarBeamEnd90Block), typeof(SoftwoodHewnLogDocksPillarBeamEnd180Block), typeof(SoftwoodHewnLogDocksPillarBeamEnd270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksPillarBeamEndFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamEndBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamEnd90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamEnd180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamEnd270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksPillarBeamEndAltBlock), typeof(SoftwoodHewnLogDocksPillarBeamEndAlt90Block), typeof(SoftwoodHewnLogDocksPillarBeamEndAlt180Block), typeof(SoftwoodHewnLogDocksPillarBeamEndAlt270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksPillarBeamEndAltFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamEndAltBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamEndAlt90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamEndAlt180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamEndAlt270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksPillarBeamJunctionBlock), typeof(SoftwoodHewnLogDocksPillarBeamJunction90Block), typeof(SoftwoodHewnLogDocksPillarBeamJunction180Block), typeof(SoftwoodHewnLogDocksPillarBeamJunction270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksPillarBeamJunctionFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamJunctionBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamJunction90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamJunction180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamJunction270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksBarrelPlatformBlock), typeof(SoftwoodHewnLogDocksBarrelPlatform90Block), typeof(SoftwoodHewnLogDocksBarrelPlatform180Block), typeof(SoftwoodHewnLogDocksBarrelPlatform270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksBarrelPlatformFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksBarrelPlatformBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksBarrelPlatform90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksBarrelPlatform180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksBarrelPlatform270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksRampABlock), typeof(SoftwoodHewnLogDocksRampA90Block), typeof(SoftwoodHewnLogDocksRampA180Block), typeof(SoftwoodHewnLogDocksRampA270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksRampAFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampABlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampA90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampA180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampA270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksRampBBlock), typeof(SoftwoodHewnLogDocksRampB90Block), typeof(SoftwoodHewnLogDocksRampB180Block), typeof(SoftwoodHewnLogDocksRampB270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksRampBFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampBBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampB90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampB180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampB270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksRampCBlock), typeof(SoftwoodHewnLogDocksRampC90Block), typeof(SoftwoodHewnLogDocksRampC180Block), typeof(SoftwoodHewnLogDocksRampC270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksRampCFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampCBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampC90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampC180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampC270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksRampDBlock), typeof(SoftwoodHewnLogDocksRampD90Block), typeof(SoftwoodHewnLogDocksRampD180Block), typeof(SoftwoodHewnLogDocksRampD270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksRampDFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampDBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampD90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampD180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampD270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksFenceSoloBlock), typeof(SoftwoodHewnLogDocksFenceSolo90Block), typeof(SoftwoodHewnLogDocksFenceSolo180Block), typeof(SoftwoodHewnLogDocksFenceSolo270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksFenceSoloFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceSoloBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceSolo90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceSolo180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceSolo270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksFenceEndCapBlock), typeof(SoftwoodHewnLogDocksFenceEndCap90Block), typeof(SoftwoodHewnLogDocksFenceEndCap180Block), typeof(SoftwoodHewnLogDocksFenceEndCap270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksFenceEndCapFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceEndCapBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceEndCap90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceEndCap180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceEndCap270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksRampsCornerBlock), typeof(SoftwoodHewnLogDocksRampsCorner90Block), typeof(SoftwoodHewnLogDocksRampsCorner180Block), typeof(SoftwoodHewnLogDocksRampsCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksRampsCornerFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampsCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampsCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampsCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampsCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksRampsCornerInvertedBlock), typeof(SoftwoodHewnLogDocksRampsCornerInverted90Block), typeof(SoftwoodHewnLogDocksRampsCornerInverted180Block), typeof(SoftwoodHewnLogDocksRampsCornerInverted270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksRampsCornerInvertedFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampsCornerInvertedBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampsCornerInverted90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampsCornerInverted180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksRampsCornerInverted270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksFenceEndCapDoubleBlock), typeof(SoftwoodHewnLogDocksFenceEndCapDouble90Block), typeof(SoftwoodHewnLogDocksFenceEndCapDouble180Block), typeof(SoftwoodHewnLogDocksFenceEndCapDouble270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksFenceEndCapDoubleFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceEndCapDoubleBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceEndCapDouble90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceEndCapDouble180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksFenceEndCapDouble270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksPillarBeamCornerBlock), typeof(SoftwoodHewnLogDocksPillarBeamCorner90Block), typeof(SoftwoodHewnLogDocksPillarBeamCorner180Block), typeof(SoftwoodHewnLogDocksPillarBeamCorner270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksPillarBeamCornerFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamCornerBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamCorner90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamCorner180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamCorner270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }
    [RotatedVariants(typeof(SoftwoodHewnLogDocksPillarBeamTBlock), typeof(SoftwoodHewnLogDocksPillarBeamT90Block), typeof(SoftwoodHewnLogDocksPillarBeamT180Block), typeof(SoftwoodHewnLogDocksPillarBeamT270Block))]
    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [IsForm(typeof(DocksPillarBeamTFormType), typeof(SoftwoodHewnLogItem))]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamTBlock : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamT90Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamT180Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

    [Serialized]
    [Wall, Constructed, Solid, BuildRoomMaterialOption]
    [BlockTier(2)]
    [Tag("Constructable")]
    public partial class SoftwoodHewnLogDocksPillarBeamT270Block : Block, IWaterLoggedBlock, IColoredBlock
    { }

}